%define anolis_release 2
%bcond_without perl_Digest_SHA_enables_digest_base
%bcond_without perl_Digest_SHA_enables_optional_test

Name:           perl-Digest-SHA
Epoch:          2
Version:        6.03
Release:        %{anolis_release}%{?dist}
Summary:        Perl extension for SHA-1/224/256/384/512
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Digest-SHA
Source0:        https://cpan.metacpan.org/authors/id/M/MS/MSHELOR/Digest-SHA-%{version}.tar.gz
Patch0:         Digest-SHA-5.93-Reset-CFLAGS.patch
BuildRequires:  coreutils findutils gcc make
BuildRequires:  perl-devel perl-generators perl-interpreter perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76 perl(Getopt::Std)
BuildRequires:  perl(strict) perl(vars) perl(Carp) perl(Cwd)
BuildRequires:  perl(Exporter) perl(Fcntl) perl(integer) perl(warnings)
BuildRequires:  perl(XSLoader) perl(FileHandle)
%if %{with perl_Digest_SHA_enables_digest_base}
BuildRequires:  perl(Digest::base)
%endif
%if %{with perl_Digest_SHA_enables_optional_test}
%if !%{defined perl_bootstrap}
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Test::Pod) >= 1.00
BuildRequires:  perl(Test::Pod::Coverage) >= 0.08
%endif
%endif

Requires:       perl(XSLoader)
Requires:       perl(Carp)
%if %{with perl_Digest_SHA_enables_digest_base}
Requires:       perl(Digest::base)
%endif

%{?perl_default_filter}

%description
Digest::SHA is a complete implementation of the NIST Secure Hash
Standard.  It gives Perl programmers a convenient way to calculate
SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, SHA-512/224, and SHA-512/256
message digests.  The module can handle all types of input, including
partial-byte data.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup -p1 -n Digest-SHA-%{version}
chmod -x examples/*
perl -MExtUtils::MakeMaker -e 'ExtUtils::MM_Unix->fixin(q{examples/dups})'

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE='%{optflags}'
%{make_build}

%install
%{make_install}
find '%{buildroot}' -type f -name '*.bs' -empty -delete
%{_fixperms} -c '%{buildroot}'

# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
rm %{buildroot}%{_libexecdir}/%{name}/t/pod.t
rm %{buildroot}%{_libexecdir}/%{name}/t/podcover.t
perl -i -pe 's{"methods.tmp"}{"/tmp/methods.tmp"}' %{buildroot}%{_libexecdir}/%{name}/t/methods.t
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%doc examples/
%{_bindir}/shasum
%{perl_vendorarch}/auto/Digest/
%{perl_vendorarch}/Digest/
%{_mandir}/man1/shasum.1*
%{_mandir}/man3/Digest::SHA.3*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes README 

%changelog
* Tue Apr 11 2023 Kaihao Bai <carlo.bai@linux.alibaba.com> - 2:6.03-2
- optimize spec

* Tue Feb 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2:6.03-1
- update to 6.03

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2:6.02-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2:6.02-1
- init from upstream
